#include <curses.h>
#include <time.h>
#include <math.h>

int main()
{
   int nr_kol, nr_wier;
   int zm_wier, zm_kol;
   int delay = 10;
   int znak;
   float kat;

   initscr();                   /* Start curses mode              */
   nodelay( stdscr, TRUE );
   keypad(stdscr, TRUE);
   curs_set(0);
   resize_term (50, 100);

   int seed = time((time_t *)NULL);
   srand(seed);
   nr_wier = rand() % LINES;
   nr_kol = rand() % COLS;
   zm_wier = ((rand() % 2)*2)-1;
   zm_kol = ((rand() % 2)*2)-1;

   while((znak = getch () )!= ' ')
   {
      switch(znak)
      {
         case KEY_UP:
            if (delay > 0)
               delay --;
            break;
         case KEY_DOWN:
            if (delay < 500)
               delay ++;
            break;
         case KEY_RIGHT:
            kat = atan2 (zm_kol, zm_wier);
            kat -= M_PI_2;
            zm_wier = (cos (kat) > 0.0) ? 1 : -1;
            zm_kol  = (sin (kat) > 0.0) ? 1 : -1;
            break;
         case KEY_LEFT:
            kat = atan2 (zm_kol, zm_wier);
            kat += M_PI_2;
            zm_wier = (cos (kat) > 0.0) ? 1 : -1;
            zm_kol  = (sin (kat) > 0.0) ? 1 : -1;
            break;
         default:
            move (nr_wier, nr_kol);
            addch ('*');
            refresh();                  /* Print it on to the real screen */
            napms(delay);
            clear();
            nr_wier +=zm_wier;
            nr_kol +=zm_kol;
            if(nr_wier < 0)
            {
               nr_wier=0;
               zm_wier=-zm_wier;
               beep();
            }
            else if(nr_wier == LINES)
            {
               nr_wier=LINES-1;
               zm_wier=-zm_wier;
               beep();
            }
            if(nr_kol < 0)
            {
               nr_kol=0;
               zm_kol=-zm_kol;
               beep();
            }
            else if(nr_kol == COLS)
            {
               nr_kol=COLS-1;
               zm_kol=-zm_kol;
               beep();
            }
      }
   }
   endwin();                    /* End curses mode                */

   return 0;
}
