#include <ncurses.h>

void fill(WINDOW * okno);

void ramka(WINDOW * okno);

int main() {
	WINDOW *okno;
	int x, y, c;

	initscr();

	start_color();
	noecho();
	init_pair(1, COLOR_RED, COLOR_BLUE);
	init_pair(2, COLOR_BLUE, COLOR_RED);
	okno = newwin(5, 40, 1, 1);
	wattrset(okno, COLOR_PAIR(1));
	fill(okno);
	ramka(okno);
	wmove(okno, 2, 2);
	wprintw(okno, "Czerwone litery na niebieskim tle.");
	wnoutrefresh(stdscr);
	wnoutrefresh(okno);
	doupdate();
	keypad(okno, TRUE);
	while(c = wgetch(okno)) {
		if (c == KEY_F(1)) {
			wattrset(okno, COLOR_PAIR(1));
			fill(okno);
			wmove(okno, 2, 2);
			wprintw(okno, "Czerwone litery na niebieskim tle.");
		} else if (c == KEY_F(2)) {
			wattrset(okno, COLOR_PAIR(2));
			fill(okno);
			wmove(okno, 2, 2);
			wprintw(okno, "Niebieskie litery na czerwonym tle.");
		} else if (c == KEY_LEFT) {
			getbegyx(okno, y, x);
			x--;
			mvwin(okno, y, x);
		} else if (c == KEY_RIGHT) {
			getbegyx(okno, y, x);
			x++;
			mvwin(okno, y, x);
		} else if (c == KEY_UP) {
			getbegyx(okno, y, x);
			y--;
			mvwin(okno, y, x);
		} else if (c == KEY_DOWN) {
			getbegyx(okno, y, x);
			y++;
			mvwin(okno, y, x);
		} else if (c == 'q') {
			endwin();
			exit(0);
		}
		ramka(okno);
		touchwin(stdscr);
		wnoutrefresh(stdscr);
		wnoutrefresh(okno);
		doupdate();
	}
	endwin();
	return 0;
}

void fill(WINDOW * okno) {
        int x, y, i;

        getmaxyx(okno, y, x);
        wmove(okno, 0, 0);
        for(i = 0; i < (x * y); i++) {
               	wprintw(okno, " ");
	}
}

void ramka(WINDOW * okno) {
	int x, y;

	box(okno, '|', '-');
	getbegyx(okno, y, x);
	wmove(okno, 0, 3);
	wprintw(okno, "<%i/%i>", x, y);
}
